﻿//////////////////////////////////////////////
// RenderDescriptor.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Includes ---------------------------------

// nkGraphics
#include "../Dll/DllDefines.h"

// nkMemory
#include <NilkinsMemory/Containers/String.h>

// Standards
#include <map>
#include <string>

/// Enums ------------------------------------

namespace nkGraphics
{
	enum class RENDER_PROPS
	{
		V_SYNC = 0
	} ;
}

/// Class ------------------------------------
	
namespace nkGraphics
{
	class DLL_GRAPHICS_EXPORT RenderDescriptor final
	{
		private :
		
			// Attributs
			std::map<RENDER_PROPS, int> _renderProperties ;
			
		public :
		
			// Constructeur, destructeur
			RenderDescriptor () ;
			~RenderDescriptor () ;

			// Getter
			int getValue (RENDER_PROPS prop) ;

			// Setter
			void setValue (RENDER_PROPS prop, int value) ;

			// Print
			nkMemory::String getAsString () ;
	} ;
}