﻿//////////////////////////////////////////////
// DefaultRenderStrategy.h
// 
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Includes ---------------------------------

// nkGraphics
#include "../../Dll/DllDefines.h"

#include "RenderStrategy.h"

// nkMemory
#include <NilkinsMemory/Containers/BufferCast.h>

/// Class ------------------------------------

namespace nkGraphics
{
	class DLL_GRAPHICS_EXPORT DefaultRenderStrategy final : public RenderStrategy
	{
		private :

			// Structures
			struct SlotEntry final
			{
				const EntityRenderInfoSlot* _slot ;
				Entity* _entity ;
			} ;

		private :

			// Attributes
			nkMemory::BufferCast<SlotEntry> _slots ;

			bool _frustumCull ;
			bool _orderQueue ;

		public :

			// Constructor, destructor
			DefaultRenderStrategy () ;
			virtual ~DefaultRenderStrategy () ;

			// Getters
			const nkMemory::BufferCast<SlotEntry>& getSlots () const ;
			bool getFrustumCull () const ;
			bool getOrderQueue () const ;

			// Setters
			void setFrustumCull (bool value) ;
			void setOrderQueue (bool value) ;

			// Execution
			virtual RenderCommandQueue bakeRenderCommandQueue (Shader* shader, bool transparent) override ;

			// Events
			virtual void updateAddRenderSlot (Entity* ent, const EntityRenderInfoSlot* slot) override ;
			virtual void updateEraseRenderSlot (Entity* ent, const EntityRenderInfoSlot* slot) override ;
	} ;
}